# Optain 데모 버전

# 릴리즈 노트

## 2025.01.24(금) - v0.8.6

## 추가 기능

- 시작 프로그램 설정 및 버전 확인 가능
- 사용자 테마 환경에 따라 라이트/다크 모드 지원
- 제스처 팝업에서 컨텍스트 팝업에 등록된 위젯 사용 가능
- 제스처 팝업에서 파일 탐색 창 사용 가능
- 각 매핑된 기능을 보여주는 하단 설명의 정보를 단순 이름이 아닌 매핑된 기능과 함께 제공
- 제스처 팝업 우측 패널에 카테고리를 추가하고 각 아이템에 설명을 추가
- 초기 사용자를 위한 기본 설정 값 반영
  - 제스처 팝업: 8개 방향에 기능 매핑
  - 컨텍스트 팝업: 번역, 요약, 쿼리 검색, 문자 작성 대체 위젯
- 마우스 특수 버튼의 명칭을 4번째, 5번째 버튼으로 수정

## 버그 개선

- 컨텍스트 팝업 문자 길이에 의한 디자인 깨짐 현상 수정
- Cloud Search 연동 문제 해결(`macOS` 이용 불가, `Google` 로그인 문제)
  - `macOS`에서는 `Microsoft Office` 서비스의 로그인을 지원하지 않도록 함
- 단축키 설정 창에서 이모티콘 설정이 비정상적으로 안 꺼지는 현상 수정
  - 동시에 단축키 커스텀 화면에서 `ESC` 키를 누르면 매핑이 되지 않고 화면이 꺼지는 현상 제거
- `macOS`에서 간혹 이전 프로그램(주로 `Finder`)에 포커스되는 버그 수정
- `macOS`에서 `Trigger Event` 무시 안함 설정 시 간혹 이벤트 무시되는 현상 수정
- 검색 창에서 불필요한 연산 및 한글 표시, 불필요한 영역 제거
- 클릭으로 기본 기능 매핑할 수 없는 현상 해결

### 현재 확인된 버그

- 클릭으로 매핑 시 미리보기 아이콘이 바로 변경(반영)되지 않는 현상

## 개발 진행 중

1. 프로그램 인식
2. 로지텍 기기로 제스처 사용 가능하도록
3. `macOS`의 매직 마우스, 트랙 패드 연동성
4. 마우스 휠 리버스
5. 매크로 강화
6. 제스처 팝업 템플릿/상태 추가
7. 운영체제 별 특화 UI

## 2024.12.10(화) - v0.8.5

## 추가 기능

- 매핑 창이 켜질 때 각 입력 요소에 바로 포커스
- 매크로 기능을 녹화하여 추가할 수 있는 기능 추가
- 매크로 기능에서 마우스 클릭/이동/스크롤 사용 가능
- 일부 스타일 디테일 업데이트

## 버그 개선

- `macOS`에서 상단 트레이의 타이틀 제거(아이콘만 표시)
- 텍스트 입력 기능에서, 텍스트가 길 경우 누락되어 입력되는 현상
- 컨텍스트 팝업이 특정 조건에서 이상한 위치에 뜨는 현상을 수정

### 현재 확인된 버그

- `AI` 관련 기능 위젯에 심각한 버그로 현재 사용 불가(수정 중)
- `macOS`에서 마우스 입력을 무시하지 않고 실행할 때 제대로 실행되지 않는 현상
- 매핑 창에서 `ESC` 눌렀을 때, 잘못된 창이 꺼지는 현상
- `macOS`에서 계속 `Finder`에 포커스하려는 현상

## 개발 진행 중

1. 프로그램 인식
2. 로지텍 기기로 제스처 사용 가능하도록
3. `macOS`의 매직 마우스, 트랙 패드 연동성
4. 마우스 휠 리버스
5. 매크로 강화
6. 제스처 팝업 템플릿/상태 추가
7. 운영체제 별 특화 UI
8. 초기 셋팅 값

---

## 2024.11.26(화) - v0.8.4

## 추가 기능

- 제스처 팝업의 `UI`를 원형에서 도넛 형태로 리뉴얼
  - 도넛에서 표시되는 내용은 아이콘으로, 이 아이콘은 모두 새롭게 설정 필요
    - 이모지를 아이콘으로 활용 가능
    - 직접 `.png`, `jpg`, `.jpeg` 파일을 업로드도 가능
  - 이전 버전에 매핑했던 단축키는 아이콘이 없으므로 모두 '⚠️'를 띄움
  - 기본 제공 키에 아이콘 포함
- 조합 단축키 미리보기 디자인 추가
- `Windows`와 `macOS` 각각 기본 제공 기능 일부 추가
- 창 최초 설정 화면 제스처 설정으로 변경
- 제스처를 바로 끌 경우 트리거 키를 무시하지 않고 실행할 수 있도록 UX 변경

## 버그 개선

- `macOS`에서 `Launchpad`와 `Mission Control`이 반대로 실행되는 현상 수정
- 설정 디자인 중 색상 일부 수정
- `Windows`의 제스처 설정에서 `ESC` 입력 시 선택 항목이 해제되지 않는 현상 수정

### 현재 확인된 버그

- 듀얼 모니터 사용 시 일부 컴퓨터에서 컨텍스트 팝업 이상한 위치에 뜨는 현상

## 개발 진행 중

1. 녹화로 매크로 설정
2. 프로그램 인식
3. 로지텍 기기로 제스처 사용 가능하도록
4. `Adobe Premiere Pro` 전용 플러그인 위젯
5. `macOS`의 매직 마우스, 트랙 패드 연동성
6. 마우스 휠 리버스
7. 마우스 기능 추가

---

## 2024.11.15(금) - v0.8.3

## 추가 기능

- 두 팝업 모두 초기 설정 값 마우스 휠 클릭으로 변경
- 단축키 설정 기능에 대해 특수 키 이모지 지원 추가
- 제스처 흰 배경에서 잘 보이도록 어두운 투명도 적용

## 버그 개선

- 단축키 등록 / 해제 시 에러로 인해 설정 불가능한 버그 수정
- 제스처 팝업 원형 잔상 제거
- 일부 한글 영어로 변경
- 매크로 매핑 내 시스템 검색 기능 미동작 수정

### 현재 확인된 버그

- 듀얼 모니터 사용 시 일부 컴퓨터에서 컨텍스트 팝업 이상한 위치에 뜨는 현상

## 개발 진행 중

1. 제스처 디자인 수정
2. 로지텍 기기로 제스처 사용 가능하도록
3. `Adobe Premiere Pro` 전용 플러그인 위젯
4. `macOS`의 매직 마우스, 트랙 패드 연동성
5. 마우스 휠 리버스
6. 마우스 기능 추가

---

## 2024.11.13(수) - v0.8.2

## 추가 기능

- 제스처 팝업 또한 키보드 단축키로 실행 가능
- 제스처에서 먼 거리 이동 시 기능 바로 실행(눌렀다 떼기 전에 실행)
- 마우스 특수 키 입력에 부제목 붙임(앞으로 가기, 뒤로 가기)

## 버그 개선

- 볼륨 조절 등 시스템 키 미동작 수정
- 간혹 `macOS`에서 제스처 입력 무시되는 버그 수정
- 컨텍스트 / 제스처 팝업 트리거 등록 시 키보드 단축키로 `Windows` 키 사용 가능
- '시간 지연'이라고 한글 명시된 부분 'Delay'로 수정

### 현재 확인된 버그

- 제스처 기능 수 변경 시 제스처 실행 키 이전 설정으로 롤백(가시적으로)
- 듀얼 모니터 사용 시 일부 컴퓨터에서 컨텍스트 팝업 이상한 위치에 뜨는 현상

## 개발 진행 중

1. 제스처 디자인 수정
2. 제스처 클릭만해도 기능이 실행 가능하도록
3. `Adobe Premiere Pro` 전용 플러그인 위젯
4. `macOS`의 매직 마우스, 트랙 패드 연동성

---

## 2024.11.08(금) - v0.8.1

## 추가 기능

- `macOS`에서 모든 화면에 팝업이 뜰 수 있음
- 제스처 팝업에 백그라운드 제거
- 제스처에서 `Open URL` 사용 시 빈 값을 입력할 수 없도록 함
- 트레이 아이콘에서 설정 창 켤 때 이미 켜져있는 경우 창에 포커스하도록 함
- 트레이 아이콘으로 앱 재시작(Restart) 가능

## 버그 개선

- 제스처에서 `Open URL`로 빈 값 실행 시 폴더가 켜지는 현상 수정
- `macOS`에서 일부 특수 기호나 숫자 입력 시 강제 종료되는 버그 해결
- 제스처 팝업으로 마지막에 실행한 기능이 컨텍스트 팝업을 통해 반복 실행되는 버그 해결
- 제스처 팝업 사용 도중 강제 종료되는 버그 해결

### 현재 확인된 버그

- 제스처 팝업 마우스로 실행 도중 동작 불가능 -> 트레이 아이콘에서 재시작 필요
- 제스처 팝업에서는 키보드로 실행을 지원하지 않음

## 개발 진행 중

1. 제스처 디자인 수정
2. 키보드로 제스처 실행
3. 제스처에서 일정 거리 이상 이동 시 기능 바로 실행
4. 제스처 클릭만해도 기능이 실행 가능하도록
5. `Adobe Premiere Pro` 전용 플러그인 위젯

---

## 2024.11.06(수) - v0.8.0

### 개발 사항

- `macOS` 임시 지원
- 로컬 및 클라우드 파일 내용 기반 AI 답변 추가
- 제스처 기능 추가
- `Google Slides`, `Google Calendar` 추가
- 설치 파일 `.exe`에서 `.msi`로 변경(이전에 다운 받았던 버전은 제거해야 합니다.)
- 검색 창 활용 가능하도록 변경
- 컨텍스트 팝업 길이 위젯 수에 따라 동적 변경
- `Ctrl`, `Cmd` 특수 조합으로 위젯 실행
- 로컬 및 클라우드 파일 검색 적중률을 개선 및 UX 수정
- 동시에 여러 `Optain`이 실행되지 않도록 수정
- 클라우드 파일 계정 연동 안정성을 강화
- 위젯을 따로 설치할 필요 없도록 함

### 현재 확인된 버그

- 제스처 팝업 마우스로 실행 도중 동작 불가능
- `macOS`에서 전체 화면으로 보여지고 있는 경우, 팝업이 뜨지 않음
- 제스처 팝업에서는 키보드로 실행을 지원하지 않음
- `macOS`에서는 제스처에서 마우스 커서가 가려지지 않음
- `macOS`에서 제스처로 `[`, `]`, `/`, `\`, `,`, `.`, `=`, `-`, `;`, `'`, ``` 등의 특수 기호를 사용할 수 없음

---

## 2024.09.23(월) - v0.7.0

### 개발 사항

- 로컬 및 클라우드 파일 검색 기능 추가
- 위젯 설정에서 `Drag & Drop`로 순서 변경 시 비정상적으로 동작하는 버그 수정
  - `Drag & Drop` 시 발생하는 위치 이슈 수정
- 조건에 의해 비활성화 된 위젯 하단으로 이동
- 검색 쿼리 위젯의 `/` 키를 통한 태그 검색의 `UX` 개선
- 검색 쿼리 위젯 태그 상태로 저장
- 검색 커리 위젯 켜질 시 입력 창에 바로 포커스
- 일부 위젯 활성화 조건 수정
  - 요약 위젯: 20자 이상 드래그
  - 작성 위젯: 10자 이상 드래그
  - 쿼리 검색 위젯: 클립보드 데이터 활용하지 않음
- 위젯들의 폴더 이름 최신화

### 현재 확인된 버그

- 컨텍스트 팝업 마우스로 실행 도중 강제 종료

---

## 2024.08.26(월) - v0.6.1

### 개발 사항

- 문서 작성 위젯 상태 저장 및 말투 추가/삭제 추가
- 위젯에서 문맥 정보 들어올 경우 우측 하단 알림 추가
- `Cache-Control`을 수정하여 위젯이 캐시되지 않도록 수정
- 컨텍스트 팝업 닫을 때 애니메이션 수정
- 컨텍스트 팝업 켜질 때 지연시간 `0.1s`에서 `0.4s`로 수정
- `Optain` 애플리케이션과 위젯의 말투 수정(Helper)

### 현재 확인된 버그

- 컨텍스트 팝업 마우스로 실행 도중 강제 종료

---

## 2024.08.18(월) - v0.6.0

### 개발 사항

- 단축키 등록하여 컨텍스트 트리거 기능 추가
- 위젯 상태 저장 구현(번역 위젯 적용)
- 컨텍스트 팝업 외부 클릭 시 컨텍스트 팝업 종료
- 검색 쿼리 위젯 개발 완료
- `AI` 검색 서비스 위젯, 유튜브 요약 위젯 제거
- 항상 켜지는 위젯 / 위젯 사이즈 조절 가능
- 번역 위젯 지원 언어 총 11가지로 변경(힌디어의 경우 `DeepL`에서 지원하지 않음)

### 현재 확인된 버그

- 컨텍스트 팝업 실행 도중 렉과 함께 강제 종료(빈도는 줄어듬)
- 단축키로 컨텍스트 트리거 시 문맥 정보가 넘어가지 않을 수 있음(특수 키와 복사가 동시에 발생해서 생기는 문제)

---

## 2024.08.07(수) - v0.5.0

### 개발 사항

- `Figma`에 정의된 데모 버전 사양 개발 완료
  1. 번역 위젯
  2. 요약 위젯
  3. 작성 위젯
  4. 유튜브 요약 위젯(추가)
  5. AI 검색 서비스 위젯(추가)
- 컨텍스트 팝업에서 키보드를 사용한 상호작용 가능
- 컨텍스트 팝업에 등록한 위젯은 저장되지 않음(껏다 켰을 때 초기화)
- 제스처 팝업에 대한 설정은 없으나, 이전 버전의 설정 값 그대로 사용 가능함

### 현재 확인된 버그

- 컨텍스트 팝업 실행 도중 렉과 함께 강제 종료
- 드래그 후 컨텍스트 팝업(위젯 결과 창) 실행 시 드래그 데이터가 간혹 넘어가지 않음
